/* FileChanges.c generated by valac 0.44.7, the Vala compiler
 * generated from FileChanges.vala, do not modify */

/* Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef enum  {
	MARLIN_FILE_CHANGES_KIND_INITIAL,
	MARLIN_FILE_CHANGES_KIND_ADDED,
	MARLIN_FILE_CHANGES_KIND_CHANGED,
	MARLIN_FILE_CHANGES_KIND_REMOVED,
	MARLIN_FILE_CHANGES_KIND_MOVED
} MarlinFileChangesKind;

#define MARLIN_FILE_CHANGES_TYPE_KIND (marlin_file_changes_kind_get_type ())
typedef struct _MarlinFileChangesChange MarlinFileChangesChange;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _marlin_file_changes_change_free0(var) ((var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _MarlinFileChangesChange {
	MarlinFileChangesKind kind;
	GFile* from;
	GFile* to;
};

extern GQueue* marlin_file_changes_queue;
GQueue* marlin_file_changes_queue = NULL;
extern GMutex marlin_file_changes_queue_mutex;
GMutex marlin_file_changes_queue_mutex = {0};

#define MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK 20
GType marlin_file_changes_kind_get_type (void) G_GNUC_CONST;
void marlin_file_changes_change_free (MarlinFileChangesChange * self);
static void marlin_file_changes_change_instance_init (MarlinFileChangesChange * self);
MarlinFileChangesChange* marlin_file_changes_change_new (void);
GQueue* marlin_file_changes_get_queue (void);
static void _marlin_file_changes_change_free0_ (gpointer var);
static inline void _g_queue_free__marlin_file_changes_change_free0_ (GQueue* self);
void marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item);
void marlin_file_changes_queue_file_added (GFile* location);
void marlin_file_changes_queue_file_changed (GFile* location);
void marlin_file_changes_queue_file_removed (GFile* location);
void marlin_file_changes_queue_file_moved (GFile* from,
                                           GFile* to);
void marlin_file_changes_consume_changes (gboolean consume_all);
void gof_directory_async_notify_files_removed (GList* files);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void gof_directory_async_notify_files_moved (GList* files);
static void _g_array_unref0_ (gpointer var);
static inline void _g_list_free__g_array_unref0_ (GList* self);
void gof_directory_async_notify_files_added (GList* files);
void gof_directory_async_notify_files_changed (GList* files);
static void _vala_GFile_free_function_content_of (gpointer data);

GType
marlin_file_changes_kind_get_type (void)
{
	static volatile gsize marlin_file_changes_kind_type_id__volatile = 0;
	if (g_once_init_enter (&marlin_file_changes_kind_type_id__volatile)) {
		static const GEnumValue values[] = {{MARLIN_FILE_CHANGES_KIND_INITIAL, "MARLIN_FILE_CHANGES_KIND_INITIAL", "initial"}, {MARLIN_FILE_CHANGES_KIND_ADDED, "MARLIN_FILE_CHANGES_KIND_ADDED", "added"}, {MARLIN_FILE_CHANGES_KIND_CHANGED, "MARLIN_FILE_CHANGES_KIND_CHANGED", "changed"}, {MARLIN_FILE_CHANGES_KIND_REMOVED, "MARLIN_FILE_CHANGES_KIND_REMOVED", "removed"}, {MARLIN_FILE_CHANGES_KIND_MOVED, "MARLIN_FILE_CHANGES_KIND_MOVED", "moved"}, {0, NULL, NULL}};
		GType marlin_file_changes_kind_type_id;
		marlin_file_changes_kind_type_id = g_enum_register_static ("MarlinFileChangesKind", values);
		g_once_init_leave (&marlin_file_changes_kind_type_id__volatile, marlin_file_changes_kind_type_id);
	}
	return marlin_file_changes_kind_type_id__volatile;
}

MarlinFileChangesChange*
marlin_file_changes_change_new (void)
{
	MarlinFileChangesChange* self;
#line 31 "../libcore/FileChanges.vala"
	self = g_slice_new0 (MarlinFileChangesChange);
#line 31 "../libcore/FileChanges.vala"
	marlin_file_changes_change_instance_init (self);
#line 31 "../libcore/FileChanges.vala"
	return self;
#line 100 "FileChanges.c"
}

static void
marlin_file_changes_change_instance_init (MarlinFileChangesChange * self)
{
}

void
marlin_file_changes_change_free (MarlinFileChangesChange * self)
{
#line 33 "../libcore/FileChanges.vala"
	_g_object_unref0 (self->from);
#line 34 "../libcore/FileChanges.vala"
	_g_object_unref0 (self->to);
#line 31 "../libcore/FileChanges.vala"
	g_slice_free (MarlinFileChangesChange, self);
#line 117 "FileChanges.c"
}

static void
_marlin_file_changes_change_free0_ (gpointer var)
{
#line 43 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL));
#line 125 "FileChanges.c"
}

static inline void
_g_queue_free__marlin_file_changes_change_free0_ (GQueue* self)
{
#line 43 "../libcore/FileChanges.vala"
	g_queue_free_full (self, (GDestroyNotify) _marlin_file_changes_change_free0_);
#line 133 "FileChanges.c"
}

GQueue*
marlin_file_changes_get_queue (void)
{
	GQueue* result = NULL;
	GQueue* _tmp0_;
	GQueue* _tmp2_;
#line 41 "../libcore/FileChanges.vala"
	g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 42 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_queue;
#line 42 "../libcore/FileChanges.vala"
	if (_tmp0_ == NULL) {
#line 148 "FileChanges.c"
		GQueue* _tmp1_;
#line 43 "../libcore/FileChanges.vala"
		_tmp1_ = g_queue_new ();
#line 43 "../libcore/FileChanges.vala"
		(marlin_file_changes_queue == NULL) ? NULL : (marlin_file_changes_queue = (_g_queue_free__marlin_file_changes_change_free0_ (marlin_file_changes_queue), NULL));
#line 43 "../libcore/FileChanges.vala"
		marlin_file_changes_queue = _tmp1_;
#line 156 "FileChanges.c"
	}
#line 46 "../libcore/FileChanges.vala"
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 48 "../libcore/FileChanges.vala"
	_tmp2_ = marlin_file_changes_queue;
#line 48 "../libcore/FileChanges.vala"
	result = _tmp2_;
#line 48 "../libcore/FileChanges.vala"
	return result;
#line 166 "FileChanges.c"
}

void
marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
#line 51 "../libcore/FileChanges.vala"
	g_return_if_fail (new_item != NULL);
#line 52 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_get_queue ();
#line 52 "../libcore/FileChanges.vala"
	queue = _tmp0_;
#line 53 "../libcore/FileChanges.vala"
	g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 54 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 54 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 54 "../libcore/FileChanges.vala"
	g_queue_push_head (queue, _tmp1_);
#line 55 "../libcore/FileChanges.vala"
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 51 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 193 "FileChanges.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 61 "../libcore/FileChanges.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "FileChanges.c"
}

void
marlin_file_changes_queue_file_added (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 58 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 59 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 59 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 60 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 60 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_ADDED;
#line 61 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 61 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 61 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 61 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 62 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 62 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 62 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 58 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 239 "FileChanges.c"
}

void
marlin_file_changes_queue_file_changed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 65 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 66 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 66 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 67 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 67 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_CHANGED;
#line 68 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 68 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 68 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 68 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 69 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 69 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 69 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 65 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 277 "FileChanges.c"
}

void
marlin_file_changes_queue_file_removed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 72 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 73 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 73 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 74 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 74 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_REMOVED;
#line 75 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 75 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 75 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 75 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 76 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 76 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 76 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 72 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 315 "FileChanges.c"
}

void
marlin_file_changes_queue_file_moved (GFile* from,
                                      GFile* to)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	GFile* _tmp5_;
	MarlinFileChangesChange* _tmp6_;
#line 79 "../libcore/FileChanges.vala"
	g_return_if_fail (from != NULL);
#line 79 "../libcore/FileChanges.vala"
	g_return_if_fail (to != NULL);
#line 80 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 80 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 81 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 81 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_MOVED;
#line 82 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 82 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (from);
#line 82 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 82 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 83 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 83 "../libcore/FileChanges.vala"
	_tmp5_ = _g_object_ref0 (to);
#line 83 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp4_->to);
#line 83 "../libcore/FileChanges.vala"
	_tmp4_->to = _tmp5_;
#line 84 "../libcore/FileChanges.vala"
	_tmp6_ = new_item;
#line 84 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 84 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp6_);
#line 79 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 366 "FileChanges.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 137 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 374 "FileChanges.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 137 "../libcore/FileChanges.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 382 "FileChanges.c"
}

static void
_g_array_unref0_ (gpointer var)
{
#line 143 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (g_array_unref (var), NULL));
#line 390 "FileChanges.c"
}

static inline void
_g_list_free__g_array_unref0_ (GList* self)
{
#line 143 "../libcore/FileChanges.vala"
	g_list_free_full (self, (GDestroyNotify) _g_array_unref0_);
#line 398 "FileChanges.c"
}

static void
_vala_GFile_free_function_content_of (gpointer data)
{
	GFile* self;
#line 195 "../libcore/FileChanges.vala"
	self = *((GFile**) data);
#line 195 "../libcore/FileChanges.vala"
	_g_object_unref0_ (self);
#line 409 "FileChanges.c"
}

static gpointer
_g_array_ref0 (gpointer self)
{
#line 198 "../libcore/FileChanges.vala"
	return self ? g_array_ref (self) : NULL;
#line 417 "FileChanges.c"
}

void
marlin_file_changes_consume_changes (gboolean consume_all)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	guint chunk_count = 0U;
	gboolean flush_needed = FALSE;
	GList* additions = NULL;
	GList* changes = NULL;
	GList* deletions = NULL;
	GList* moves = NULL;
#line 88 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_get_queue ();
#line 88 "../libcore/FileChanges.vala"
	queue = _tmp0_;
#line 91 "../libcore/FileChanges.vala"
	additions = NULL;
#line 92 "../libcore/FileChanges.vala"
	changes = NULL;
#line 93 "../libcore/FileChanges.vala"
	deletions = NULL;
#line 94 "../libcore/FileChanges.vala"
	moves = NULL;
#line 443 "FileChanges.c"
	{
		gboolean _tmp1_ = FALSE;
#line 101 "../libcore/FileChanges.vala"
		chunk_count = (guint) 0;
#line 101 "../libcore/FileChanges.vala"
		_tmp1_ = TRUE;
#line 101 "../libcore/FileChanges.vala"
		while (TRUE) {
#line 452 "FileChanges.c"
			MarlinFileChangesChange* change = NULL;
			GQueue* _tmp3_;
			gpointer _tmp4_;
			MarlinFileChangesChange* _tmp5_;
			MarlinFileChangesChange* _tmp31_;
			MarlinFileChangesChange* _tmp32_;
			MarlinFileChangesKind _tmp33_;
#line 101 "../libcore/FileChanges.vala"
			if (!_tmp1_) {
#line 462 "FileChanges.c"
				guint _tmp2_;
#line 101 "../libcore/FileChanges.vala"
				_tmp2_ = chunk_count;
#line 101 "../libcore/FileChanges.vala"
				chunk_count = _tmp2_ + 1;
#line 468 "FileChanges.c"
			}
#line 101 "../libcore/FileChanges.vala"
			_tmp1_ = FALSE;
#line 102 "../libcore/FileChanges.vala"
			g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 103 "../libcore/FileChanges.vala"
			_tmp3_ = queue;
#line 103 "../libcore/FileChanges.vala"
			_tmp4_ = g_queue_pop_tail (_tmp3_);
#line 103 "../libcore/FileChanges.vala"
			change = (MarlinFileChangesChange*) _tmp4_;
#line 104 "../libcore/FileChanges.vala"
			g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 108 "../libcore/FileChanges.vala"
			_tmp5_ = change;
#line 108 "../libcore/FileChanges.vala"
			if (_tmp5_ == NULL) {
#line 109 "../libcore/FileChanges.vala"
				flush_needed = TRUE;
#line 488 "FileChanges.c"
			} else {
				gboolean _tmp6_ = FALSE;
				GList* _tmp7_;
				gboolean _tmp10_ = FALSE;
				GList* _tmp11_;
				gboolean _tmp14_ = FALSE;
				GList* _tmp15_;
				gboolean _tmp18_ = FALSE;
				GList* _tmp19_;
				gboolean _tmp22_ = FALSE;
#line 112 "../libcore/FileChanges.vala"
				_tmp7_ = additions;
#line 112 "../libcore/FileChanges.vala"
				if (_tmp7_ != NULL) {
#line 503 "FileChanges.c"
					MarlinFileChangesChange* _tmp8_;
					MarlinFileChangesKind _tmp9_;
#line 113 "../libcore/FileChanges.vala"
					_tmp8_ = change;
#line 113 "../libcore/FileChanges.vala"
					_tmp9_ = _tmp8_->kind;
#line 113 "../libcore/FileChanges.vala"
					_tmp6_ = _tmp9_ != MARLIN_FILE_CHANGES_KIND_ADDED;
#line 512 "FileChanges.c"
				} else {
#line 112 "../libcore/FileChanges.vala"
					_tmp6_ = FALSE;
#line 516 "FileChanges.c"
				}
#line 112 "../libcore/FileChanges.vala"
				flush_needed = _tmp6_;
#line 115 "../libcore/FileChanges.vala"
				_tmp11_ = changes;
#line 115 "../libcore/FileChanges.vala"
				if (_tmp11_ != NULL) {
#line 524 "FileChanges.c"
					MarlinFileChangesChange* _tmp12_;
					MarlinFileChangesKind _tmp13_;
#line 116 "../libcore/FileChanges.vala"
					_tmp12_ = change;
#line 116 "../libcore/FileChanges.vala"
					_tmp13_ = _tmp12_->kind;
#line 116 "../libcore/FileChanges.vala"
					_tmp10_ = _tmp13_ != MARLIN_FILE_CHANGES_KIND_CHANGED;
#line 533 "FileChanges.c"
				} else {
#line 115 "../libcore/FileChanges.vala"
					_tmp10_ = FALSE;
#line 537 "FileChanges.c"
				}
#line 115 "../libcore/FileChanges.vala"
				flush_needed = flush_needed | _tmp10_;
#line 118 "../libcore/FileChanges.vala"
				_tmp15_ = moves;
#line 118 "../libcore/FileChanges.vala"
				if (_tmp15_ != NULL) {
#line 545 "FileChanges.c"
					MarlinFileChangesChange* _tmp16_;
					MarlinFileChangesKind _tmp17_;
#line 119 "../libcore/FileChanges.vala"
					_tmp16_ = change;
#line 119 "../libcore/FileChanges.vala"
					_tmp17_ = _tmp16_->kind;
#line 119 "../libcore/FileChanges.vala"
					_tmp14_ = _tmp17_ != MARLIN_FILE_CHANGES_KIND_MOVED;
#line 554 "FileChanges.c"
				} else {
#line 118 "../libcore/FileChanges.vala"
					_tmp14_ = FALSE;
#line 558 "FileChanges.c"
				}
#line 118 "../libcore/FileChanges.vala"
				flush_needed = flush_needed | _tmp14_;
#line 121 "../libcore/FileChanges.vala"
				_tmp19_ = deletions;
#line 121 "../libcore/FileChanges.vala"
				if (_tmp19_ != NULL) {
#line 566 "FileChanges.c"
					MarlinFileChangesChange* _tmp20_;
					MarlinFileChangesKind _tmp21_;
#line 122 "../libcore/FileChanges.vala"
					_tmp20_ = change;
#line 122 "../libcore/FileChanges.vala"
					_tmp21_ = _tmp20_->kind;
#line 122 "../libcore/FileChanges.vala"
					_tmp18_ = _tmp21_ != MARLIN_FILE_CHANGES_KIND_REMOVED;
#line 575 "FileChanges.c"
				} else {
#line 121 "../libcore/FileChanges.vala"
					_tmp18_ = FALSE;
#line 579 "FileChanges.c"
				}
#line 121 "../libcore/FileChanges.vala"
				flush_needed = flush_needed | _tmp18_;
#line 124 "../libcore/FileChanges.vala"
				if (!consume_all) {
#line 124 "../libcore/FileChanges.vala"
					_tmp22_ = chunk_count >= ((guint) MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK);
#line 587 "FileChanges.c"
				} else {
#line 124 "../libcore/FileChanges.vala"
					_tmp22_ = FALSE;
#line 591 "FileChanges.c"
				}
#line 124 "../libcore/FileChanges.vala"
				flush_needed = flush_needed | _tmp22_;
#line 595 "FileChanges.c"
			}
#line 128 "../libcore/FileChanges.vala"
			if (flush_needed) {
#line 599 "FileChanges.c"
				GList* _tmp23_;
				GList* _tmp25_;
				GList* _tmp27_;
				GList* _tmp29_;
#line 134 "../libcore/FileChanges.vala"
				_tmp23_ = deletions;
#line 134 "../libcore/FileChanges.vala"
				if (_tmp23_ != NULL) {
#line 608 "FileChanges.c"
					GList* _tmp24_;
#line 135 "../libcore/FileChanges.vala"
					deletions = g_list_reverse (deletions);
#line 136 "../libcore/FileChanges.vala"
					_tmp24_ = deletions;
#line 136 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_removed (_tmp24_);
#line 137 "../libcore/FileChanges.vala"
					(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 137 "../libcore/FileChanges.vala"
					deletions = NULL;
#line 620 "FileChanges.c"
				}
#line 140 "../libcore/FileChanges.vala"
				_tmp25_ = moves;
#line 140 "../libcore/FileChanges.vala"
				if (_tmp25_ != NULL) {
#line 626 "FileChanges.c"
					GList* _tmp26_;
#line 141 "../libcore/FileChanges.vala"
					moves = g_list_reverse (moves);
#line 142 "../libcore/FileChanges.vala"
					_tmp26_ = moves;
#line 142 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_moved (_tmp26_);
#line 143 "../libcore/FileChanges.vala"
					(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 143 "../libcore/FileChanges.vala"
					moves = NULL;
#line 638 "FileChanges.c"
				}
#line 146 "../libcore/FileChanges.vala"
				_tmp27_ = additions;
#line 146 "../libcore/FileChanges.vala"
				if (_tmp27_ != NULL) {
#line 644 "FileChanges.c"
					GList* _tmp28_;
#line 147 "../libcore/FileChanges.vala"
					additions = g_list_reverse (additions);
#line 148 "../libcore/FileChanges.vala"
					_tmp28_ = additions;
#line 148 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_added (_tmp28_);
#line 149 "../libcore/FileChanges.vala"
					(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 149 "../libcore/FileChanges.vala"
					additions = NULL;
#line 656 "FileChanges.c"
				}
#line 152 "../libcore/FileChanges.vala"
				_tmp29_ = changes;
#line 152 "../libcore/FileChanges.vala"
				if (_tmp29_ != NULL) {
#line 662 "FileChanges.c"
					GList* _tmp30_;
#line 153 "../libcore/FileChanges.vala"
					changes = g_list_reverse (changes);
#line 154 "../libcore/FileChanges.vala"
					_tmp30_ = changes;
#line 154 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_changed (_tmp30_);
#line 155 "../libcore/FileChanges.vala"
					(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 155 "../libcore/FileChanges.vala"
					changes = NULL;
#line 674 "FileChanges.c"
				}
			}
#line 159 "../libcore/FileChanges.vala"
			_tmp31_ = change;
#line 159 "../libcore/FileChanges.vala"
			if (_tmp31_ == NULL) {
#line 161 "../libcore/FileChanges.vala"
				_marlin_file_changes_change_free0 (change);
#line 161 "../libcore/FileChanges.vala"
				(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 161 "../libcore/FileChanges.vala"
				(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 161 "../libcore/FileChanges.vala"
				(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 161 "../libcore/FileChanges.vala"
				(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 161 "../libcore/FileChanges.vala"
				return;
#line 693 "FileChanges.c"
			}
#line 165 "../libcore/FileChanges.vala"
			_tmp32_ = change;
#line 165 "../libcore/FileChanges.vala"
			_tmp33_ = _tmp32_->kind;
#line 165 "../libcore/FileChanges.vala"
			switch (_tmp33_) {
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_ADDED:
#line 703 "FileChanges.c"
				{
					GList* _tmp34_;
					MarlinFileChangesChange* _tmp35_;
					GFile* _tmp36_;
					GFile* _tmp37_;
#line 167 "../libcore/FileChanges.vala"
					_tmp34_ = additions;
#line 167 "../libcore/FileChanges.vala"
					if (_tmp34_ == NULL) {
#line 168 "../libcore/FileChanges.vala"
						(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 168 "../libcore/FileChanges.vala"
						additions = NULL;
#line 717 "FileChanges.c"
					}
#line 171 "../libcore/FileChanges.vala"
					_tmp35_ = change;
#line 171 "../libcore/FileChanges.vala"
					_tmp36_ = _tmp35_->from;
#line 171 "../libcore/FileChanges.vala"
					_tmp37_ = _g_object_ref0 (_tmp36_);
#line 171 "../libcore/FileChanges.vala"
					additions = g_list_prepend (additions, _tmp37_);
#line 172 "../libcore/FileChanges.vala"
					break;
#line 729 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_CHANGED:
#line 733 "FileChanges.c"
				{
					GList* _tmp38_;
					MarlinFileChangesChange* _tmp39_;
					GFile* _tmp40_;
					GFile* _tmp41_;
#line 175 "../libcore/FileChanges.vala"
					_tmp38_ = changes;
#line 175 "../libcore/FileChanges.vala"
					if (_tmp38_ == NULL) {
#line 176 "../libcore/FileChanges.vala"
						(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 176 "../libcore/FileChanges.vala"
						changes = NULL;
#line 747 "FileChanges.c"
					}
#line 179 "../libcore/FileChanges.vala"
					_tmp39_ = change;
#line 179 "../libcore/FileChanges.vala"
					_tmp40_ = _tmp39_->from;
#line 179 "../libcore/FileChanges.vala"
					_tmp41_ = _g_object_ref0 (_tmp40_);
#line 179 "../libcore/FileChanges.vala"
					changes = g_list_prepend (changes, _tmp41_);
#line 180 "../libcore/FileChanges.vala"
					break;
#line 759 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_REMOVED:
#line 763 "FileChanges.c"
				{
					GList* _tmp42_;
					MarlinFileChangesChange* _tmp43_;
					GFile* _tmp44_;
					GFile* _tmp45_;
#line 183 "../libcore/FileChanges.vala"
					_tmp42_ = deletions;
#line 183 "../libcore/FileChanges.vala"
					if (_tmp42_ == NULL) {
#line 184 "../libcore/FileChanges.vala"
						(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 184 "../libcore/FileChanges.vala"
						deletions = NULL;
#line 777 "FileChanges.c"
					}
#line 187 "../libcore/FileChanges.vala"
					_tmp43_ = change;
#line 187 "../libcore/FileChanges.vala"
					_tmp44_ = _tmp43_->from;
#line 187 "../libcore/FileChanges.vala"
					_tmp45_ = _g_object_ref0 (_tmp44_);
#line 187 "../libcore/FileChanges.vala"
					deletions = g_list_prepend (deletions, _tmp45_);
#line 188 "../libcore/FileChanges.vala"
					break;
#line 789 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_MOVED:
#line 793 "FileChanges.c"
				{
					GList* _tmp46_;
					GArray* pair = NULL;
					GArray* _tmp47_;
					GArray* _tmp48_;
					MarlinFileChangesChange* _tmp49_;
					GFile* _tmp50_;
					GFile* _tmp51_;
					GArray* _tmp52_;
					MarlinFileChangesChange* _tmp53_;
					GFile* _tmp54_;
					GFile* _tmp55_;
					GArray* _tmp56_;
					GArray* _tmp57_;
#line 191 "../libcore/FileChanges.vala"
					_tmp46_ = moves;
#line 191 "../libcore/FileChanges.vala"
					if (_tmp46_ == NULL) {
#line 192 "../libcore/FileChanges.vala"
						(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 192 "../libcore/FileChanges.vala"
						moves = NULL;
#line 816 "FileChanges.c"
					}
#line 195 "../libcore/FileChanges.vala"
					_tmp47_ = g_array_sized_new (FALSE, FALSE, sizeof (GFile*), (guint) 2);
#line 195 "../libcore/FileChanges.vala"
					g_array_set_clear_func (_tmp47_, (GDestroyNotify) _vala_GFile_free_function_content_of);
#line 195 "../libcore/FileChanges.vala"
					pair = _tmp47_;
#line 196 "../libcore/FileChanges.vala"
					_tmp48_ = pair;
#line 196 "../libcore/FileChanges.vala"
					_tmp49_ = change;
#line 196 "../libcore/FileChanges.vala"
					_tmp50_ = _tmp49_->from;
#line 196 "../libcore/FileChanges.vala"
					_tmp51_ = _g_object_ref0 (_tmp50_);
#line 196 "../libcore/FileChanges.vala"
					g_array_append_val (_tmp48_, _tmp51_);
#line 197 "../libcore/FileChanges.vala"
					_tmp52_ = pair;
#line 197 "../libcore/FileChanges.vala"
					_tmp53_ = change;
#line 197 "../libcore/FileChanges.vala"
					_tmp54_ = _tmp53_->to;
#line 197 "../libcore/FileChanges.vala"
					_tmp55_ = _g_object_ref0 (_tmp54_);
#line 197 "../libcore/FileChanges.vala"
					g_array_append_val (_tmp52_, _tmp55_);
#line 198 "../libcore/FileChanges.vala"
					_tmp56_ = pair;
#line 198 "../libcore/FileChanges.vala"
					_tmp57_ = _g_array_ref0 (_tmp56_);
#line 198 "../libcore/FileChanges.vala"
					moves = g_list_prepend (moves, _tmp57_);
#line 199 "../libcore/FileChanges.vala"
					_g_array_unref0 (pair);
#line 199 "../libcore/FileChanges.vala"
					break;
#line 854 "FileChanges.c"
				}
				default:
				{
#line 202 "../libcore/FileChanges.vala"
					g_assert_not_reached ();
#line 860 "FileChanges.c"
				}
			}
#line 101 "../libcore/FileChanges.vala"
			_marlin_file_changes_change_free0 (change);
#line 865 "FileChanges.c"
		}
	}
#line 87 "../libcore/FileChanges.vala"
	(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 87 "../libcore/FileChanges.vala"
	(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 87 "../libcore/FileChanges.vala"
	(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 87 "../libcore/FileChanges.vala"
	(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 876 "FileChanges.c"
}

